class Animal {
  virtual void talk() { ... }
  virtual void think() { ... }
  virtual void act() { ... }
};

class AnimalRole { // muss nicht Unterklasse von Animal sein!
public:
  enum {DOG, CAT};
  AnimalRole() {
    roles[DOG] = 0;
    roles[CAT] = 0;
    _role = DOG;
  }
  Animal* operator->() {
    return roles[_role];}

  void role(int r) {
    _role = r;
    if (roles[_role]=0) {
       switch(r) {
         case DOG: roles[_role] = new Dog(); break;
         case CAT: roles[_role] = new Cat(); break;
       }
    }
  }

protected:
  int _role;
  Animal* roles[2];
  // hier Rollen-gemeinsame Membervariablen
};

class Dog: public Animal {
public:
  void talk() { ... "wuff" ... }
  void act() { ... }
};

class Cat: public Animal {
public:
  void talk() { ... "miau" ... }
  void think() { ... }
};

//Verwendung:
AnimalRole x;
x.role(AnimalRole::DOG);
x->talk(); x->think(); x->act();
x.role(AnimalRole::CAT);
x->talk(); x->think(); x->act();
